unit UStyle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CorelButton, ExtCtrls, Utils, Spin, Buttons;

type
  TfSty = class(TForm)
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    shape: TShape;
    bColor: TCorelButton;
    cd: TColorDialog;
    bCancel: TCorelButton;
    eName: TEdit;
    Label2: TLabel;
    bOk: TCorelButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label3: TLabel;
    eSize: TSpinEdit;
    Label4: TLabel;
    bBack: TSpeedButton;
    bComment: TSpeedButton;
    bReserved: TSpeedButton;
    bIdentifier: TSpeedButton;
    bSymbol: TSpeedButton;
    bString: TSpeedButton;
    bNumber: TSpeedButton;
    bAssembler: TSpeedButton;
    cBold: TCheckBox;
    cItalic: TCheckBox;
    cUnder: TCheckBox;
    sDemo: TShape;
    lDemo: TLabel;
    cbFont: TComboBox;
    procedure bColorClick(Sender: TObject);
    function getColor(const cor: TColor):TColor;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bCancelClick(Sender: TObject);
    procedure bOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cBoldClick(Sender: TObject);
    procedure cItalicClick(Sender: TObject);
    procedure cUnderClick(Sender: TObject);
    procedure bBackClick(Sender: TObject);
    procedure cbFontChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fSty: TfSty;
  k: string;
  ns: integer;
  index: byte;

  cores: array [0..7] of TColor;
  aBold: array [0..7] of boolean;
  aItalic: array [0..7] of boolean;
  aUnder: array [0..7] of boolean;

implementation

uses Upri;

{$R *.DFM}

function TfSty.getColor(const cor: TColor):TColor;
begin
  result := cor;
  cd.color := cor;
  if cd.execute then
    result := cd.color;
end;

procedure TfSty.bColorClick(Sender: TObject);
begin
  cores[index] := getcolor(cores[index]);
  shape.brush.color := cores[index];
  case index of
    0: bBackClick(bBack);
    1: bBackClick(bComment);
    2: bBackClick(bReserved);
    3: bBackClick(bIdentifier);
    4: bBackClick(bSymbol);
    5: bBackClick(bString);
    6: bBackClick(bNumber);
    7: bBackClick(bAssembler);
  end;
end;

procedure TfSty.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  release;
end;

procedure TfSty.bCancelClick(Sender: TObject);
begin
  close;
end;

procedure TfSty.bOkClick(Sender: TObject);
begin
  if eName.Text = '' then
    erro('You must enter a style name.')
  else begin
    if fPri.inserting then begin
      ns := ReadRegInt(kcu,kPas,'Styles');
      SaveToRegInt(kcu,kPas,'Styles',ns + 1);
      k := kPas + '\Style_' + inttostr(ns);
    end;

    // Name
    SaveToReg(kcu,k,'Name',eName.text);
    // font
    SaveToReg(kcu,k,'Font Name',cbFont.Text);
    SaveToRegInt(kcu,k,'Font Size',eSize.Value);
    // Background
    SaveToRegInt(kcu,k + '\Background','Color',cores[0]);
    // Comment
    SaveToRegInt(kcu,k + '\Comment','Color',cores[1]);
    SaveToRegBool(kcu,k + '\Comment','Bold',aBold[1]);
    SaveToRegBool(kcu,k + '\Comment','Italic',aItalic[1]);
    SaveToRegBool(kcu,k + '\Comment','Underline',aUnder[1]);
    // Reserved
    SaveToRegInt(kcu,k + '\Reserved','Color',cores[2]);
    SaveToRegBool(kcu,k + '\Reserved','Bold',aBold[2]);
    SaveToRegBool(kcu,k + '\Reserved','Italic',aItalic[2]);
    SaveToRegBool(kcu,k + '\Reserved','Underline',aUnder[2]);
    // Identifier
    SaveToRegInt(kcu,k + '\Identifier','Color',cores[3]);
    // Symbol
    SaveToRegInt(kcu,k + '\Symbol','Color',cores[4]);
    SaveToRegBool(kcu,k + '\Symbol','Bold',aBold[4]);
    SaveToRegBool(kcu,k + '\Symbol','Italic',aItalic[4]);
    SaveToRegBool(kcu,k + '\Symbol','Underline',aUnder[4]);
    // String
    SaveToRegInt(kcu,k + '\String','Color',cores[5]);
    SaveToRegBool(kcu,k + '\String','Bold',aBold[5]);
    SaveToRegBool(kcu,k + '\String','Italic',aItalic[5]);
    SaveToRegBool(kcu,k + '\String','Underline',aUnder[5]);
    // Number
    SaveToRegInt(kcu,k + '\Number','Color',cores[6]);
    SaveToRegBool(kcu,k + '\Number','Bold',aBold[6]);
    SaveToRegBool(kcu,k + '\Number','Italic',aItalic[6]);
    SaveToRegBool(kcu,k + '\Number','Underline',aUnder[6]);
    // Assembler
    SaveToRegInt(kcu,k + '\Assembler','Color',cores[7]);
    SaveToRegBool(kcu,k + '\Assembler','Bold',aBold[7]);
    SaveToRegBool(kcu,k + '\Assembler','Italic',aItalic[7]);
    SaveToRegBool(kcu,k + '\Assembler','Underline',aUnder[7]);

    if fPri.inserting then begin
      fPri.cb.Items.add(eName.Text);
      fPri.cb.itemindex := fPri.cb.items.count - 1;
      fPri.cbChange(fPri.cb);
    end;

    close;
  end;
end;

procedure TfSty.FormCreate(Sender: TObject);
begin
  cbFont.Items.Assign(Screen.Fonts);
  if fPri.inserting then begin
    Ename.Text := '';
    cbFont.ItemIndex := cbFont.Items.IndexOf('Courier New');

    eSize.Value:= 3;
    // Background
    cores[0] := clWhite;
    // Comment
    cores[1] := clGray;
    aBold[1] := false;
    aItalic[1] := true;
    aUnder[1] := false;
    // Reserved
    cores[2] := clNavy;
    aBold[2] := true;
    aItalic[2] := false;
    aUnder[2] := false;
    // Identifier
    cores[3] := clBlack;
    // Symbol
    cores[4] := clBlue;
    aBold[4] := false;
    aItalic[4] := false;
    aUnder[4] := false;
    // String
    cores[5] := clPurple;
    aBold[5] := false;
    aItalic[5] := false;
    aUnder[5] := false;
    // Number
    cores[6] := clRed;
    aBold[6] := false;
    aItalic[6] := false;
    aUnder[6] := false;
    // Assembler
    cores[7] := clGreen;
    aBold[7] := false;
    aItalic[7] := false;
    aUnder[7] := false;
  end
  else begin
    caption := 'Edit Style';
    k := kPas + '\Style_' + inttostr(fPri.htmstyle);

    // Name
    eName.Text := ReadReg(kcu,k,'Name');
    // Font Name
    cbFont.ItemIndex := cbFont.Items.IndexOf(ReadReg(kcu,k,'Font Name'));
    // Font Size
    eSize.Value := ReadRegInt(kcu,k,'Font Size');

    // Background
    cores[0] := ReadRegInt(kcu,k + '\Background' ,'Color');
    // Comment
    cores[1] := ReadRegInt(kcu,k + '\Comment','Color');
    aBold[1] := ReadRegBool(kcu,k + '\Comment','Bold');
    aItalic[1] := ReadRegBool(kcu,k + '\Comment','Italic');
    aUnder[1] := ReadRegBool(kcu,k + '\Comment','Underline');
    // Reserved
    cores[2] := ReadRegInt(kcu,k + '\Reserved','Color');
    aBold[2] := ReadRegBool(kcu,k + '\Reserved','Bold');
    aItalic[2] := ReadRegBool(kcu,k + '\Reserved','Italic');
    aUnder[2] := ReadRegBool(kcu,k + '\Reserved','Underline');
    // Identifier
    cores[3] := ReadRegInt(kcu,k + '\Identifier','Color');
    // Symbol
    cores[4] := ReadRegInt(kcu,k + '\Symbol','Color');
    aBold[4] := ReadRegBool(kcu,k + '\Symbol','Bold');
    aItalic[4] := ReadRegBool(kcu,k + '\Symbol','Italic');
    aUnder[4] := ReadRegBool(kcu,k + '\Symbol','Underline');
    // String
    cores[5] := ReadRegInt(kcu,k + '\String','Color');
    aBold[5] := ReadRegBool(kcu,k + '\String','Bold');
    aItalic[5] := ReadRegBool(kcu,k + '\String','Italic');
    aUnder[5] := ReadRegBool(kcu,k + '\String','Underline');
    // Number
    cores[6] := ReadRegInt(kcu,k + '\Number','Color');
    aBold[6] := ReadRegBool(kcu,k + '\Number','Bold');
    aItalic[6] := ReadRegBool(kcu,k + '\Number','Italic');
    aUnder[6] := ReadRegBool(kcu,k + '\Number','Underline');
    // Assembler
    cores[7] := ReadRegInt(kcu,k + '\Assembler','Color');
    aBold[7] := ReadRegBool(kcu,k + '\Assembler','Bold');
    aItalic[7] := ReadRegBool(kcu,k + '\Assembler','Italic');
    aUnder[7] := ReadRegBool(kcu,k + '\Assembler','Underline');
  end;
  bBackClick(bBack);
end;

procedure TfSty.cBoldClick(Sender: TObject);
begin
  aBold[index] := cBold.Checked;
  case index of
    0: bBackClick(bBack);
    1: bBackClick(bComment);
    2: bBackClick(bReserved);
    3: bBackClick(bIdentifier);
    4: bBackClick(bSymbol);
    5: bBackClick(bString);
    6: bBackClick(bNumber);
    7: bBackClick(bAssembler);
  end;
end;

procedure TfSty.cItalicClick(Sender: TObject);
begin
  aItalic[index] := cItalic.Checked;
  case index of
    0: bBackClick(bBack);
    1: bBackClick(bComment);
    2: bBackClick(bReserved);
    3: bBackClick(bIdentifier);
    4: bBackClick(bSymbol);
    5: bBackClick(bString);
    6: bBackClick(bNumber);
    7: bBackClick(bAssembler);
  end;
end;

procedure TfSty.cUnderClick(Sender: TObject);
begin
  aUnder[index] := cUnder.Checked;
  case index of
    0: bBackClick(bBack);
    1: bBackClick(bComment);
    2: bBackClick(bReserved);
    3: bBackClick(bIdentifier);
    4: bBackClick(bSymbol);
    5: bBackClick(bString);
    6: bBackClick(bNumber);
    7: bBackClick(bAssembler);
  end;
end;

procedure TfSty.bBackClick(Sender: TObject);
begin
  index := (Sender as TSpeedButton).Tag;

  cBold.Enabled := (index <> 0)and(index <> 3);
  cItalic.Enabled := (index <> 0)and(index <> 3);
  cUnder.Enabled := (index <> 0)and(index <> 3);

  shape.brush.color := cores[Index];
  sDemo.Brush.color := cores[0];
  lDemo.Font.name := cbFont.Text;
  lDemo.Font.Style := [];
  if (index <> 0)and(index <> 3) then begin
    cBold.checked := aBold[Index];
    cItalic.checked := aItalic[Index];
    cUnder.checked := aUnder[Index];
    with lDemo.Font do begin
      color := cores[Index];
      if abold[Index] then
        style := style + [fsBold];
      if aItalic[Index] then
        style := style + [fsItalic];
      if aUnder[Index] then
        style := style + [fsUnderline];
    end;
  end
  else begin
    cBold.Checked := false;
    cItalic.Checked := false;
    cUnder.Checked := false;
    lDemo.Font.color := cores[3];
  end;
end;

procedure TfSty.cbFontChange(Sender: TObject);
begin
  lDemo.Font.name := cbFont.Text;
end;

end.
