unit Upri;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CorelButton, ExtCtrls, utils, OleCtrls, SHDocVw_TLB;

type
  TfPri = class(TForm)
    Panel1: TPanel;
    bAdd: TCorelButton;
    lFiles: TListBox;
    open: TOpenDialog;
    bClear: TCorelButton;
    bConvert: TCorelButton;
    GroupBox1: TGroupBox;
    cb: TComboBox;
    CorelButton1: TCorelButton;
    CorelButton3: TCorelButton;
    CorelButton2: TCorelButton;
    Bevel1: TBevel;
    Panel2: TPanel;
    wb: TWebBrowser;
    bConvertAll: TCorelButton;
    cColor: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    lPasSize: TLabel;
    lHtmSize: TLabel;
    CorelButton4: TCorelButton;
    procedure bAddClick(Sender: TObject);
    procedure bClearClick(Sender: TObject);
    procedure bConvertClick(Sender: TObject);
    procedure changepas(var list: TStringList);
    function changeline(str: string):string;
    function ColorToHtmlColor(cor: TColor):string;
    procedure FormCreate(Sender: TObject);
    procedure cbChange(Sender: TObject);
    procedure defaultstyle;
    procedure CorelButton2Click(Sender: TObject);
    procedure CorelButton1Click(Sender: TObject);
    procedure CorelButton3Click(Sender: TObject);
    procedure antes_depois(ind: byte; cor: string; bo,it,un: boolean);
    procedure lFilesClick(Sender: TObject);
    procedure lFilesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CorelButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    inserting: boolean;
    htmstyle: integer;
  end;

const
  aRes: array [0..93] of string =
    (
     ('absolute'),
     ('abstract'),
     ('and'),
     ('array'),
     ('as'),
     ('asm'),
     ('assembler'),
     ('begin'),
     ('case'),
     ('cdecl'),
     ('class'),
     ('const'),
     ('constructor'),
     ('contains'),
     ('default'),
     ('destructor'),
     ('dispid'),
     ('dispinterface'),
     ('div'),
     ('do'),
     ('downto'),
     ('dynamic'),
     ('else'),
     ('end'),
     ('except'),
     ('export'),
     ('exports'),
     ('external'),
     ('far'),
     ('file'),
     ('finalization'),
     ('finally'),
     ('for'),
     ('forward'),
     ('function'),
     ('goto'),
     ('if'),
     ('implementation'),
     ('in'),
     ('inherited'),
     ('initialization'),
     ('inline'),
     ('interface'),
     ('is'),
     ('label'),
     ('library'),
     ('message'),
     ('mod'),
     ('near'),
     ('nil'),
     ('not'),
     ('object'),
     ('of'),
     ('on'),
     ('or'),
     ('out'),
     ('overload'),
     ('override'),
     ('package'),
     ('packed'),
     ('pascal'),
     ('private'),
     ('procedure'),
     ('program'),
     ('property'),
     ('protected'),
     ('public'),
     ('published'),
     ('raise'),
     ('record'),
     ('register'),
     ('reintroduce'),
     ('repeat'),
     ('requires'),
     ('resourcestring'),
     ('safecall'),
     ('set'),
     ('shl'),
     ('shr'),
     ('stdcall'),
     ('string'),
     ('then'),
     ('threadvar'),
     ('to'),
     ('try'),
     ('type'),
     ('unit'),
     ('until'),
     ('uses'),
     ('var'),
     ('virtual'),
     ('while'),
     ('with'),
     ('xor')
     );

  blank = ' ';

  aSpecial: array [0..22] of string =
    (
     ('#'),
     ('$'),
     ('&'),
     (#39), // aspa simples
     ('('),
     (')'),
     ('*'),
     ('+'),
     (','),
     ('-'),
     ('.'),
     ('/'),
     (':'),
     (';'),
     ('<'),
     ('='),
     ('>'),
     ('@'),
     ('['),
     (']'),
     ('^'),
     ('{'),
     ('}')
//     ('(*'),
//     ('(.'),
//     ('*)'),
//     ('.)'),
//     ('..'),
//     ('//'),
//     (':='),
//     ('<='),
//     ('>='),
//     ('<>')
     );

var
  fPri: TfPri;
  nextIsComment,
  nextIsAsm: boolean;
  commentby,def: string;

  fontname: string;
  fontsize: integer;
  backcor: string;
  cor: string[7];
  Bol: boolean;
  Ita: boolean;
  Und: boolean;
  antes: array [0..7] of string;
  depois: array [0..7] of string;

implementation

uses UStyle, UAbout;

{$R *.DFM}

procedure TfPri.bAddClick(Sender: TObject);
var
  n: integer;
  temp: TStringList;

  function JaExiste(str: string):boolean;
  var
    g: integer;
  begin
    result := false;
    for g := 0 to temp.count - 1 do
      if UpperCase(str) = UpperCase(temp.strings[g]) then begin
        result := true;
        break;
      end;
  end;

begin
  with open do
    if execute then
      if files.Count > 0 then begin
        try
          temp := TStringList.Create;
          temp.Assign(lFiles.Items);
          for n := 0 to files.count - 1 do
            if not JaExiste(files.strings[n]) then
              lFiles.Items.Add(files.strings[n]);
        finally
          temp.free;
        end;
      end;
  lFilesClick(lFiles);
end;

procedure TfPri.bClearClick(Sender: TObject);
var
  n: integer;
begin
  n := 0;
  while n <= lFiles.Items.Count - 1 do begin
    if lFiles.Selected[n] then begin
      lFiles.Items.Delete(n);
      dec(n);
    end;
    inc(n);
  end;
  lFilesClick(lFiles);
end;

function foundinres(pal: string):boolean;
var
  g: integer;
begin
  result := false;
  for g := 0 to length(aRes) - 1 do
    if UpperCase(aRes[g]) = UpperCase(pal) then begin
      result := true;
      break;
    end;
end;

function isSpecial(ch: string):boolean;
var
  s: integer;
begin
  result := false;
  for s := 0 to length(aSpecial) - 1 do
    if ch = aSpecial[s] then begin
      result := true;
      break;
    end;
end;

function IsNumber(ch: char):boolean;
begin
  if ch in ['0'..'9'] then
    result := true
  else
    result := false;
end;

function TfPri.changeline(str: string):string;
var
  palavra,newstr: string;
  n,p,len,x: integer;
begin
  n := 1;
  palavra := '';
  len := length(str);

  if nextIsComment then begin
    p := Pos(commentby,str);
    if p > 0 then begin
      str := copy(str,1,p + length(commentby) - 1) +
             depois[1] +
             copy(str,p + length(commentby),len);
      n := p + length(depois[1]) + length(commentby);
      nextIsComment := false;
    end
    else begin
      result := str;
      exit;
    end;
  end;

  if nextIsAsm then begin
    p := Pos('END',Uppercase(str));
    if p > 0 then begin
      str := copy(str,1,p - 1) +
             depois[7] +
             copy(str,p,len);
      n := p + length(depois[7]);
      nextIsAsm := false;
    end
    else begin
      result := str;
      exit;
    end;
  end;

  len := length(str);
  while n <= len do begin
    if ((str[n] = blank)or(isSpecial(str[n]))and(str[n] <> '$')) then begin
      palavra := '';

      if str[n] = '#'  then begin
        if (char(ord(str[n - 1]) - 32) in ['A'..'Z'])or(str[n - 1] = '_') then
          inc(n)
        else begin
          x := n + 1;
          while (str[x] = '$')or(str[x] = '^')or(IsNumber(str[x]))do begin
            if str[x] = '$' then
              if IsNumber(str[x - 1]) then
                break;

            inc(x);

            if str[x - 1] = '^' then
              if str[x + 1] <> '^' then begin
                inc(x);
                break;
              end;
          end;
          str := copy(str,1,n - 1) +
                 antes[5] +
                 copy(str,n,x - n) +
                 depois[5] +
                 copy(str,x,len);
          inc(n,length(antes[5]) + length(depois[5]) + x - n - 1);
        end;
      end
      else
      if (str[n] = '/')and(str[n + 1] = '/') then begin
        str := copy(str,1,n - 1) +
               antes[1] +
               copy(str,n,len) +
               depois[1];
        break;
      end
      else
      if str[n] = '{' then begin
        newstr := copy(str,n + 1,len);
        p := Pos('}',newstr);
        if p > 0 then begin
          str := copy(str,1,n - 1) +
                 antes[1] +
                 copy(str,n,p + 1) +
                 depois[1] +
                 copy(newstr,p + 1,length(newstr));
          inc(n,length(antes[1]) + length(depois[1]) + p);
        end
        else begin
          str := copy(str,1,n - 1) +
                 antes[1] +
                 copy(str,n,length(str));
          commentby := '}';
          nextIsComment := true;
          break;
        end;
      end
      else
      if (str[n] = '(')and(str[n + 1] = '*') then begin
        newstr := copy(str,n + 2,len);
        p := Pos('*)',newstr);
        if p > 0 then begin
          str := copy(str,1,n - 1) +
                 antes[1] +
                 copy(str,n,p + 3) +
                 depois[1] +
                 copy(newstr,p + 2,length(newstr));
          inc(n,length(antes[1]) + length(depois[1]) + p + 2);
        end
        else begin
          str := copy(str,1,n - 1) +
                 antes[1] +
                 copy(str,n,length(str));
          commentby := '*)';
          nextIsComment := true;
          break;
        end;
      end
      else
      if str[n] = #39 then begin
        newstr := copy(str,n + 1,len);
        p := Pos(#39,newstr);
        if p > 0 then begin
          str := copy(str,1,n - 1) +
                 antes[5] +
                 str[n] + copy(newstr,1,p) +
                 depois[5] +
                 copy(newstr,p + 1,length(newstr));
          inc(n,length(antes[5]) + length(depois[5]) + p);
        end
        else begin
          str := copy(str,1,n - 1) +
                 antes[5] +
                 copy(str,n,length(str)) +
                 depois[5];
          break;
        end;
      end
      else
      if IsSpecial(str[n]) then begin
          x := n + 1;
          while (IsSpecial(str[x]))and
                (str[x] <> #39)and
                ((str[x] <> '(')and(str[x + 1] <> '*'))and
                (str[x] <> '{')and
                ((str[x] <> '/')and(str[x + 1] <> '/')) do begin

            inc(x);
          end;
          str := copy(str,1,n - 1) +
                 antes[4] +
                 copy(str,n,x - n) +
                 depois[4] +
                 copy(str,x,len);
          inc(n,length(antes[4]) + length(depois[4]) + x - n - 1);
      end;
    end
    else
    if (str[n] = '$')and
       ( (str[n - 1] <> '_')and(not(char(ord(str[n - 1]) - 32) in ['A'..'Z'])) ) then begin
      x := n + 1;
      while (str[x] = '$')or(IsNumber(str[x]))or
            (char(ord(str[x]) - 32) in ['A'..'F']) do
        inc(x);
      str := copy(str,1,n - 1) +
             antes[6] +
             copy(str,n,x - n) +
             depois[6] +
             copy(str,x,len);
      inc(n,length(antes[6]) + length(depois[6]) + x - n - 1);
    end
    else
    if (IsNumber(str[n]))and
       ( (str[n - 1] <> '_')and(not(char(ord(str[n - 1]) - 32) in ['A'..'Z'])) ) then begin
      x := n + 1;
      while (str[x] = '$')or(IsNumber(str[x]))or
            (char(ord(str[x]) - 32) in ['A'..'F']) do
//        if not(char(ord(str[x - 1]) - 32) in ['A'..'F']) then
          inc(x);
      str := copy(str,1,n - 1) +
             antes[6] +
             copy(str,n,x - n) +
             depois[6] +
             copy(str,x,len);
      inc(n,length(antes[6]) + length(depois[6]) + x - n - 1);
    end
    else
    if IsNumber(str[n]) then begin
      palavra := palavra + str[n];
      x := n + 1;
      while IsNumber(str[x]) do begin
        palavra := palavra + str[x];
        inc(x);
      end;
      n := x;
    end
    else begin
      palavra := palavra + str[n];

      if (foundinres(palavra))and((n = len)or(str[n + 1] = ' ')or(IsSpecial(str[n + 1]))) then begin
        if Uppercase(palavra) = 'ASM' then begin
          newstr := copy(str,n + 1,length(str));
          p := Pos('END',Uppercase(newstr));
          if p > 0 then begin
            str := copy(str,1,n - 3) +
                   antes[2] +
                   copy(str,n - 2,3) +
                   depois[2] +
                   antes[7] +
                   copy(newstr,1,p - 1) +
                   depois[7] +
                   copy(newstr,p,length(newstr));
            inc(n,length(antes[2]) + length(depois[2]) +
                  length(antes[7]) + length(depois[7]) +
                  length(newstr) - 4);
          end
          else begin
            str := copy(str,1,n - 3) +
                   antes[2] +
                   copy(str,n - 2,3) +
                   depois[2] +
                   antes[7] +
                   copy(str,n + 1,length(str));
            nextIsAsm := true;
            break;
          end;
        end
        else begin
          p := n - length(palavra) + 1;
          str := copy(str,1,p - 1) +
                 antes[2] +
                 palavra +
                 depois[2] +
                 copy(str,p + length(palavra),len);
          inc(n,length(antes[2]) + length(depois[2]));
        end;

        palavra := '';
      end;
    end;
    len := length(str);
    inc(n);
  end;
  result := str;
end;

procedure TfPri.changepas(var list: TStringList);
var
  n: integer;
begin
  for n := 0 to list.count - 1 do
    list.strings[n] := changeline(list.strings[n]);
end;

function TfPri.ColorToHtmlColor(cor: TColor):string;
begin
  result := inttohex(cor,6);
  result := '#' + result[5] + result[6] + result[3] + result[4] + result[1] + result[2];
end;

procedure TfPri.antes_depois(ind: byte; cor: string; bo,it,un: boolean);
begin
  antes[ind] := '<FONT COLOR="' + cor + '">';
  depois[ind] := '</FONT>';

  if bo then begin
    antes[ind] := '<B>' + antes[ind];
    depois[ind] := depois[ind] + '</B>';
  end;
  if it then begin
    antes[ind] := '<I>' + antes[ind];
    depois[ind] := depois[ind] + '</I>';
  end;
  if un then begin
    antes[ind] := '<U>' + antes[ind];
    depois[ind] := depois[ind] + '</U>';
  end;
end;

procedure TfPri.bConvertClick(Sender: TObject);
var
  htm,pas: TStringList;
  fontface, { identifier }
  fname,
  fontcolor,
  k: string;
  z,m,n: integer;
  useStyles: boolean;
begin
  if lFiles.items.Count <= 0 then begin
    erro('Add one or more files to convert.');
    exit;
  end;

  useStyles := cColor.Checked;

  if useStyles then begin
    k := kPas + '\Style_' + inttostr(fPri.htmstyle);
    // Font Name
    fontname := ReadReg(kcu,k,'Font Name');
    // Font Size
    fontsize := ReadRegInt(kcu,k,'Font Size');
    // Background
    backcor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Background' ,'Color'));
    // Comment
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Comment','Color'));
    Bol := ReadRegBool(kcu,k + '\Comment','Bold');
    Ita := ReadRegBool(kcu,k + '\Comment','Italic');
    Und := ReadRegBool(kcu,k + '\Comment','Underline');
    antes_depois(1,cor,bol,ita,und);
    // Reserved
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Reserved','Color'));
    Bol := ReadRegBool(kcu,k + '\Reserved','Bold');
    Ita := ReadRegBool(kcu,k + '\Reserved','Italic');
    Und := ReadRegBool(kcu,k + '\Reserved','Underline');
    antes_depois(2,cor,bol,ita,und);
    // Identifier
    fontcolor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Identifier','Color'));
    // Symbol
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Symbol','Color'));
    Bol := ReadRegBool(kcu,k + '\Symbol','Bold');
    Ita := ReadRegBool(kcu,k + '\Symbol','Italic');
    Und := ReadRegBool(kcu,k + '\Symbol','Underline');
    antes_depois(4,cor,bol,ita,und);
    // String
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\String','Color'));
    Bol := ReadRegBool(kcu,k + '\String','Bold');
    Ita := ReadRegBool(kcu,k + '\String','Italic');
    Und := ReadRegBool(kcu,k + '\String','Underline');
    antes_depois(5,cor,bol,ita,und);
    // Number
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Number','Color'));
    Bol := ReadRegBool(kcu,k + '\Number','Bold');
    Ita := ReadRegBool(kcu,k + '\Number','Italic');
    Und := ReadRegBool(kcu,k + '\Number','Underline');
    antes_depois(6,cor,bol,ita,und);
    // Assembler
    cor := ColorToHtmlColor(ReadRegInt(kcu,k + '\Assembler','Color'));
    Bol := ReadRegBool(kcu,k + '\Assembler','Bold');
    Ita := ReadRegBool(kcu,k + '\Assembler','Italic');
    Und := ReadRegBool(kcu,k + '\Assembler','Underline');
    antes_depois(7,cor,bol,ita,und);
  end
  else begin
    backcor := '#FFFFFF';
    fontname := 'Tahoma';
    fontsize := 3;
    fontcolor := '#000000';
  end;

  nextIsComment := false;
  nextIsAsm := false;
  try
    Screen.Cursor := crHourGlass;
    htm := TStringList.Create;
    pas := TStringList.Create;
    try
      if Sender = bConvertAll then begin
        m := 0;
        n := lFiles.items.count - 1;
      end
      else begin
        m := lFiles.ItemIndex;
        n := lFiles.ItemIndex;
      end;

      while m <= n do begin
        fname := lFiles.Items.Strings[m];
        htm.clear;
        pas.clear;
        pas.LoadFromFile(fname);
        with htm do begin
          add('<HTML>');
          add('<HEAD>');
          add('<TITLE>' + fname + '</TITLE>');
          add('<META NAME="GENERATOR" CONTENT="Pascal To HTML by Bruno Lovatti - ' +
              formatdatetime('dd/mm/yyyy - hh:mm:ss',now) + '">');
          add('</HEAD>');

          add('<BODY BGCOLOR="' + backcor + '">');
          add('<FONT FACE="' + fontname +
              '" SIZE="' + inttostr(fontsize) +
              '" COLOR="' + fontcolor + '">');
          add('<A NAME=' + uppercase(extractfilename(fname)) +
              '><CENTER><H3>' + uppercase(extractfilename(fname)) + '</H3></CENTER></A>');
          add('</FONT>');
          add('<HR>');
          add('<PRE>');
          add('<FONT FACE="' + fontname +
              '" SIZE="' + inttostr(fontsize) +
              '" COLOR="' + fontcolor + '">');

          if useStyles then
            changepas(pas);

          for z := 0 to pas.count - 1 do
            htm.add(pas.strings[z]);

          add('</FONT>');
          add('</PRE>');
          add('</BODY>');
          add('</HTML>');
          SaveToFile(changefileext(fname,'.htm'));
        end;
        inc(m);
      end;
    except
    end;
  finally
    htm.free;
    pas.free;
    lFilesClick(lFiles);
    screen.cursor := crDefault;
  end;
end;

procedure TfPri.FormCreate(Sender: TObject);
var
  n,x: integer;
  kn: string;

  defhtm: TStringList;
  flags,
  framename,
  postdata,
  headers: OleVariant;
begin
  try
    try
      n := ReadRegInt(kcu,kPas,'Styles');
    except
      n := 0;
    end;
  finally
    if n = 0 then begin
      SaveToRegInt(kcu,kPas,'Styles',1);
      defaultstyle;
      n := 1;
    end;
  end;

  for x := 0 to n - 1 do begin
    kn := kPas + '\Style_' + inttostr(x);
    cb.Items.add(ReadReg(kcu,kn,'Name'));
  end;

  try
    cb.itemindex := ReadRegInt(kcu,kPas,'LastStyle');
  except
    SaveToRegInt(kcu,kPas,'LastStyle',0);
    cb.itemindex := 0;
  end;
  cbChange(cb);

  def := ExtractFilePath(ParamStr(0));
  if def[length(def)] <> '\' then
    def := def + '\';
  def := def + 'default.htm';
  if not FileExists(def) then begin
    defhtm := TStringList.Create;
    with defhtm do begin
      add('<HTML>');
      add('<HEAD>');
      add('<TITLE>DEFAULT.HTM</TITLE>');
      add('<META NAME="GENERATOR" CONTENT="Pascal To HTML by Bruno Lovatti - ' +
          formatdatetime('dd/mm/yyyy - hh:mm:ss',now) + '">');
          add('</HEAD>');
      add('<BODY BGCOLOR="#000000">');
      add('<FONT FACE="Tahoma" SIZE="3 " COLOR="#FFFFFF">');
      add('<A NAME=DEFAULT><CENTER><H3>PASCAL TO HTML by BRUNO LOVATTI</H3></CENTER></A>');
      add('</FONT>');
      add('<HR>');
      add('<PRE>');
      add('<FONT FACE="Tahoma" SIZE="3 " COLOR="#FFFFFF">');
      add('<CENTER>Copyright (c) 1999, Bruno Lovatti<BR><BR><BR>');
      add('</FONT>');
      add('</PRE>');
      add('</BODY>');
      add('</HTML>');

      SaveToFile(def);
      free;
    end;
  end;
  wb.Navigate('file:///' + def,
              flags,
              framename,
              postdata,
              headers
              );
end;

procedure TfPri.defaultstyle;
var
  k: string;
begin
  k := kPas + '\Style_' + inttostr(htmstyle);
  if not ExistKey(kcu,k) then begin
    SaveToReg(kcu,k,'Name','Default');
    // font
    SaveToReg(kcu,k,'Font Name','Tahoma');
    SaveToRegInt(kcu,k,'Font Size',3);
    // Background
    SaveToRegInt(kcu,k + '\Background','Color',clwhite);
    SaveToRegBool(kcu,k + '\Background','Bold',false);
    SaveToRegBool(kcu,k + '\Background','Italic',false);
    SaveToRegBool(kcu,k + '\Background','Underline',false);
    // Comment
    SaveToRegInt(kcu,k + '\Comment','Color',clGray);
    SaveToRegBool(kcu,k + '\Comment','Bold',false);
    SaveToRegBool(kcu,k + '\Comment','Italic',true);
    SaveToRegBool(kcu,k + '\Comment','Underline',false);
    // Reserved
    SaveToRegInt(kcu,k + '\Reserved','Color',clNavy);
    SaveToRegBool(kcu,k + '\Reserved','Bold',true);
    SaveToRegBool(kcu,k + '\Reserved','Italic',false);
    SaveToRegBool(kcu,k + '\Reserved','Underline',false);
    // Identifier
    SaveToRegInt(kcu,k + '\Identifier','Color',clBlack);
    // Symbol
    SaveToRegInt(kcu,k + '\Symbol','Color',clBlue);
    SaveToRegBool(kcu,k + '\Symbol','Bold',false);
    SaveToRegBool(kcu,k + '\Symbol','Italic',false);
    SaveToRegBool(kcu,k + '\Symbol','Underline',false);
    // String
    SaveToRegInt(kcu,k + '\String','Color',clPurple);
    SaveToRegBool(kcu,k + '\String','Bold',false);
    SaveToRegBool(kcu,k + '\String','Italic',false);
    SaveToRegBool(kcu,k + '\String','Underline',false);
    // Number
    SaveToRegInt(kcu,k + '\Number','Color',clRed);
    SaveToRegBool(kcu,k + '\Number','Bold',false);
    SaveToRegBool(kcu,k + '\Number','Italic',false);
    SaveToRegBool(kcu,k + '\Number','Underline',false);
    // Assembler
    SaveToRegInt(kcu,k + '\Assembler','Color',clGreen);
    SaveToRegBool(kcu,k + '\Assembler','Bold',false);
    SaveToRegBool(kcu,k + '\Assembler','Italic',false);
    SaveToRegBool(kcu,k + '\Assembler','Underline',false);
  end;
end;

procedure TfPri.cbChange(Sender: TObject);
begin
  htmstyle := cb.itemindex;
  SaveToRegInt(kcu,kPas,'LastStyle',htmstyle);
  if htmstyle = 0 then
    defaultstyle;
end;

procedure TfPri.CorelButton2Click(Sender: TObject);
var
  ns: integer;
  ks: string;
begin
  if cb.itemindex = 0 then
    erro('Impossible to delete de default style.')
  else
  if pergunta('Are you sure ?') = IDYes then begin
    DeleteKeyFromReg(kcu,kPas + '\Style_' + inttostr(cb.itemindex));
    ns := ReadRegInt(kcu,kPas,'Styles');
    SaveToRegInt(kcu,kPas,'Styles',ns - 1);
    cb.Items.Delete(cb.itemindex);
    cb.Itemindex := cb.items.count - 1;
    cbChange(cb);
  end;
end;

procedure TfPri.CorelButton1Click(Sender: TObject);
begin
  inserting := true;
  fSty := TfSty.Create(Self);
  fSty.ShowModal;
end;

procedure TfPri.CorelButton3Click(Sender: TObject);
begin
  inserting := false;
  fSty := TfSty.Create(Self);
  fSty.ShowModal;
end;

procedure TfPri.lFilesClick(Sender: TObject);
var
  flags,
  framename,
  postdata,
  headers: OleVariant;
  fname,fname1: string;
begin
  if lFiles.items.count <= 0 then begin
    fname := def;
    lPasSize.Caption := '0';
    lHtmSize.Caption := '0';
  end
  else begin
    fname := lFiles.items.Strings[lFiles.Itemindex];
    lPasSize.Caption := FormatFloat('###,###,###',fsize(fname));
    fname := ChangeFileExt(fname,'.htm');
    fname1 := fname + 'l';
    if FileExists(fname)then
      fname := fname
    else
    if FileExists(fname1) then
      fname := fname1
    else
      fname := def;
    if fname <> def then
      lHtmSize.Caption := FormatFloat('###,###,###',fsize(fname))
    else
      lHtmSize.Caption := '0';
  end;
  wb.Navigate('file:///' + fname,
              flags,
              framename,
              postdata,
              headers
              );
end;

procedure TfPri.lFilesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  b: integer;
begin
  if key = VK_DELETE then
    if lFiles.Items.Count > 0 then begin
      b := 0;
      while b <= lFiles.Items.Count - 1 do
        if lFiles.Selected[b] then
          lFiles.Items.Delete(b)
        else
          inc(b);

      lFilesClick(lFiles);
    end;
end;

procedure TfPri.CorelButton4Click(Sender: TObject);
begin
  fAbout := TfAbout.Create(self);
  fAbout.ShowModal;
end;

end.
