unit Utils;

interface

uses Windows, Forms, Registry, SysUtils;

function fSize(const FileName: string): Longint;
procedure Erro(Text: String);
procedure Info(Text: String);
function Pergunta(Text: String):Integer;
function ReadReg(Root: Integer; Key,Data: string):string;
procedure SaveToReg(Root: Integer; Key,Data,Value:string);
function ReadRegInt(Root: Integer; Key,data: string):integer;
procedure SaveToRegInt(Root: Integer; Key,Data: string; value: integer);
function ReadRegBool(Root: Integer; Key,data: string):boolean;
procedure SaveToRegBool(Root: Integer; Key,Data: string; Value: boolean);
procedure DeleteValueFromReg(Root: Integer; Key,Val: String);
function ExistKey(Root: Integer; Key: String): Boolean;
procedure DeleteKeyFromReg(Root: Integer; Key: String);

const
  kPas = 'Software\Bruno Lovatti\Pascal to HTML';
  kcu = HKEY_CURRENT_USER;

implementation

function fSize(const FileName: string): Longint;
var
  SearchRec: TSearchRec;
begin
  if FindFirst(ExpandFileName(FileName), faAnyFile, SearchRec) = 0 then
    Result := SearchRec.Size
  else Result := -1;
  FindClose(SearchRec);
end;

function ReadReg(Root: Integer; Key,Data: String):String;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  ReadReg := Reg.ReadString(Data);
  Reg.Destroy;
end;

procedure SaveToReg(Root: Integer; Key,Data,Value: String);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  Reg.WriteString(Data,Value);
  Reg.Destroy;
end;

function ReadRegInt(Root: Integer; Key,data: string):integer;
var
  Reg: TRegistry;
begin
  result := 0;
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  ReadRegInt := Reg.ReadInteger(Data);
  Reg.Destroy;
end;

procedure SaveToRegInt(Root: Integer; Key,Data: string; Value: integer);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  Reg.WriteInteger(Data,Value);
  Reg.Destroy;
end;

function ReadRegBool(Root: Integer; Key,data: string):boolean;
var
  Reg: TRegistry;
begin
  result := false;
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  ReadRegBool := Reg.ReadBool(Data);
  Reg.Destroy;
end;

procedure SaveToRegBool(Root: Integer; Key,Data: string; Value: boolean);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,True);
  Reg.WriteBool(Data,Value);
  Reg.Destroy;
end;

procedure DeleteValueFromReg(Root: Integer; Key,Val: String);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.OpenKey(Key,False);
  Reg.DeleteValue(Val);
  Reg.Destroy;
end;

procedure DeleteKeyFromReg(Root: Integer; Key: String);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Reg.DeleteKey(Key);
  Reg.Destroy;
end;

function ExistKey(Root: Integer; Key: String): Boolean;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := Root;
  Result := Reg.KeyExists(Key);
  Reg.Destroy;
end;

procedure Erro(Text: String);
begin
  Application.MessageBox(PChar(Text),'Pascal To HTML !!',mb_Ok + mb_IconStop);
end;

procedure Info(Text: String);
begin
  Application.MessageBox(PChar(Text),'Pascal To HTML !!',mb_Ok + mb_IconInformation);
end;

function Pergunta(Text: String):Integer;
begin
  Pergunta := Application.MessageBox(PChar(Text),'Pascal To HTML !!',mb_YesNo + mb_IconQuestion);
end;

end.
